org.springframework.jmx.support

## Class WebSphereMBeanServerFactoryBean

- java.lang.Object
- - org.springframework.jmx.support.WebSphereMBeanServerFactoryBean

All Implemented Interfaces:
  FactoryBean<MBeanServer>, InitializingBean

    public class WebSphereMBeanServerFactoryBean
    extends Object
    implements FactoryBean<MBeanServer>, InitializingBean

`FactoryBean` that obtains a WebSphere `MBeanServer` reference through WebSphere's proprietary `AdminServiceFactory` API, available on WebSphere 5.1 and higher.

Exposes the `MBeanServer` for bean references. This FactoryBean is a direct alternative to `MBeanServerFactoryBean`, which uses standard JMX 1.2 API to access the platform's MBeanServer.

See Javadoc for WebSphere's `AdminServiceFactory` and `MBeanFactory`.

Since:
  2.0.3
Author:
  Juergen Hoeller, Rob Harrop
See Also:
  `MBeanServer`, `MBeanServerFactoryBean`

### Constructor Summary

Constructors
Constructor and Description
`WebSphereMBeanServerFactoryBean()`

### Method Summary

Methods
`void` `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`MBeanServer` `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class<? extends MBeanServer>` `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### WebSphereMBeanServerFactoryBean

    public WebSphereMBeanServerFactoryBean()

### Method Detail

#### afterPropertiesSet

    public void afterPropertiesSet()
                            throws MBeanServerNotFoundException

Description copied from interface: `InitializingBean`
Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

Specified by:
  `afterPropertiesSet` in interface `InitializingBean`
Throws:
  `MBeanServerNotFoundException`

#### getObject

    public MBeanServer getObject()

Description copied from interface: `FactoryBean`
Return an instance (possibly shared or independent) of the object managed by this factory.

As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

Specified by:
  `getObject` in interface `FactoryBean<MBeanServer>`
Returns:
  an instance of the bean (can be `null`)
See Also:
  `FactoryBeanNotInitializedException`

#### getObjectType

    public Class<? extends MBeanServer> getObjectType()

Description copied from interface: `FactoryBean`
Return the type of object that this FactoryBean creates, or `null` if not known in advance.

This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

Specified by:
  `getObjectType` in interface `FactoryBean<MBeanServer>`
Returns:
  the type of object that this FactoryBean creates, or `null` if not known at the time of the call
See Also:
  `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

#### isSingleton

    public boolean isSingleton()

Description copied from interface: `FactoryBean`
Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

Specified by:
  `isSingleton` in interface `FactoryBean<MBeanServer>`
Returns:
  whether the exposed object is a singleton
See Also:
  `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`